Name:       bundle
Summary:    String key-val dictionary ADT
Version:    0.3.2
Release:    0
Group:      System/Libraries
License:    Apache-2.0
Source0:        bundle-%{version}.tar.gz
Source1001:     bundle.manifest
BuildRequires:  cmake
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(dlog)
BuildRequires:  pkgconfig(capi-base-common)
BuildRequires:  pkgconfig(json-glib-1.0)
BuildRequires:  pkgconfig(gmock)

%if 0%{?gcov:1}
BuildRequires:  lcov
BuildRequires:  zip
%endif

%description
Simple string key-val dictionary ADT

%package devel
Summary:    String key-val dictionary ADT (devel)
Group:      Development/Libraries
Requires:   %{name} = %{version}-%{release}

%description devel
Simple string key-val dictionary ADT (devel)

#################################################
# unittests
#################################################
%package unittests
Summary:    GTest for bundle
Group:      Development/Libraries

%description unittests
GTest for bundle

#################################################
# gcov
#################################################
%if 0%{?gcov:1}
%package gcov
Summary:    Simple string key-val dictionary ADT (gcov)
Group:      Application Framework/Testing

%description gcov
Simple string key-val dictionary ADT gcov objects
%endif

%prep
%setup -q -n %{name}-%{version}
cp %{SOURCE1001} .

%build
%if 0%{?gcov:1}
export CFLAGS+=" -fprofile-arcs -ftest-coverage"
export CXXFLAGS+=" -fprofile-arcs -ftest-coverage"
export FFLAGS+=" -fprofile-arcs -ftest-coverage"
export LDFLAGS+=" -lgcov"
%endif

%cmake -DVERSION=%{version} .
%__make %{?_smp_mflags}

%if 0%{?gcov:1}
mkdir -p gcov-obj
find . -name '*.gcno' -exec cp '{}' gcov-obj ';'
%endif

%install
%make_install

%if 0%{?gcov:1}
mkdir -p %{buildroot}%{_datadir}/gcov/obj
install -m 0644 gcov-obj/* %{buildroot}%{_datadir}/gcov/obj
%endif

%check
ctest --output-on-failure %{?_smp_mflags}
%if 0%{?gcov:1}
lcov -c --ignore-errors graph --no-external -q -d . -o bundle.info
genhtml bundle.info -o bundle.out
zip -r bundle.zip bundle.out bundle.info
install -m 0644 bundle.zip %{buildroot}%{_datadir}/gcov/
%endif

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post unittests
%if 0%{?gcov:1}
%{_bindir}/bundle_unittests
%endif

%files
%manifest %{name}.manifest
%defattr(-,root,root,-)
%{_libdir}/libbundle.so.*
%license LICENSE

%files devel
%manifest %{name}.manifest
%defattr(-,root,root,-)
%{_includedir}/*.h
%{_libdir}/pkgconfig/bundle.pc
%{_libdir}/libbundle.so

#################################################
# unittests
#################################################
%files unittests
%{_bindir}/bundle_unittests

#################################################
# bundle-gcov
#################################################
%if 0%{?gcov:1}
%files gcov
%{_datadir}/gcov/*
%endif
